;EasyCodeName=Module1,1
.686 ; create 32 bit code
.Model flat, StdCall  ;32 bit memory model
Option CaseMap :none  ; case sensitive

;The MASM32 Runtime Library include file.
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include	\masm32\include\masm32rt.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.Const
 Two = 2  ; assign number 2 to the word Two as a constant variable

.Code

start:
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	Call Main
	inkey        ; pause the screen while waiting for user to press any key
	             ; to continue
    exit
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

Main Proc Uses Ebx Esi  ; preserve registers Ebx and Esi
	Local Number:DWord
	Local numAmt:DWord
	Local toPower:DWord
	Local WantContinue:DWord
	; Number is the number being mulitipled
	; numAmt is the number of times 2 is multiplied by itself
	; toPower is just the numerical value for the power of 2
	; WantContinue is the sentinel value for while loop
    ;--------------------------------------------------------

    ; Eax, Ebx, Edx, and Esi are registers

   Mov WantContinue, 0   ; initialize WantContinue to zero

  .While ((WantContinue >= 0) && (WantContinue < -1))
  ; while WantContinue is greater than or equal to 0 And
  ; WantContinue is less than -1 do
  	print chr$(13, 10)  ; a carriage return line feed will be outputted to the
  	                    ; screen
    print chr$("A positive integer must be between 1 and 29 !", 13, 10)
    Mov numAmt, sval(input("Enter a positive integer for the Number of times 2 to be multiplied by itself : "))
    .If (numAmt > 0) && (numAmt <= 29)  ; check if numAmt is in the correct number
    	                                ; range
      Mov Edx, numAmt     ; set Edx = numAmt
      Mov toPower, Edx    ; set toPower = Edx
      Mov Number, Two     ; set Number = 2
      Mov Ebx, Two        ; set Ebx = 2
      Mov Esi, 1          ; initialize Esi = 1 to begin while loop

      print chr$(13, 10)
      print chr$(" ")           ; a space will be outputted to the screen
      print str$(Two)           ; 2 will be outputted to the screen

	  .While Esi <= numAmt      ; while Esi is less than or equal to numAmt do
	    Mov Eax, Ebx            ; set Eax = Ebx
	    IMul Number             ; Eax = Eax * Number
	    Mov Ebx, Eax            ; set Ebx = Eax
	    print chr$(" x ")       ; * 2 will be outputted to the screen as many
	    print str$(Two)         ;  times according to while loop
	    Add Esi, 1              ; Esi = Esi + 1
      .EndW
      Add toPower, 1            ; toPower = toPower + 1

      print chr$(" = ")         ; =  will be outputted to the screen
      print str$(Two)           ; 2 will be outputted to the screen
      print chr$("^")           ; ^ will be outputted to the screen
      print str$(toPower)
      print chr$(" = ")
      print str$(Ebx), 13, 10   ; the result of the multiplication will be
                                ; outputted to the screen
      print chr$(13, 10)        ; a return key space will be outputted to the screen
    .ElseIf
       print chr$(13, 10)
       print chr$("You entered invalid integer!", 13, 10)
       print chr$(13, 10)
       Mov WantContinue, 0
    .EndIf
    Mov WantContinue, sval(input("Enter -1 to quit program : "))
    Invoke ClearScreen ; clears the screen
  .EndW
    print chr$(13, 10)
    Ret
Main EndP

End start
